#ifndef BOHRER_C
#define BOHRER_C

#include "main.h"


unsigned char Koordinatensteuerung;
unsigned char EngineStepStatus[2];
unsigned char Transference;
unsigned char CommandData[16];
unsigned char DataAmount;
signed int PositionCache[3];
unsigned int UDRValue;
unsigned char Rueckgabewert;
unsigned char Rueckgabewert_s;
unsigned int Bohrzeitzaehler;
unsigned char Servostatus;
unsigned char Interupt_running;
unsigned char Clock_Syckle;
unsigned int Servowert;
unsigned char Sicherheitszaehler;

signed char Engine_Direction_Counter;
unsigned char EngineSpeed_Cache=0;

const unsigned int curve_bla[] PROGMEM = {0, 174, 348, 523, 697, 871, 1045, 1218, 1391, 1564, 1736, 
1908, 2079, 2249, 2419, 2588, 2756, 2923, 3090, 3255, 3420, 3583, 3746, 3907, 4067, 4226, 4383, 
4539, 4694, 4848, 4999, 5150, 5299, 5446, 5591, 5735, 5877, 6018, 6156, 6293, 6427, 6560, 6691, 
6819, 6946, 7071, 7193, 7313, 7431, 7547, 7660, 7771, 7880, 7986, 8090, 8191, 8290, 8386, 8480, 
8571, 8660, 8746, 8829, 8910, 8987, 9063, 9135, 9205, 9271, 9335, 9396, 9455, 9510, 9563, 9612, 
9659, 9702, 9743, 9781, 9816, 9848, 9876, 9902, 9925, 9945, 9961, 9975, 9986, 9993, 9998, 10000};

void initStructs(void)
{
	memset(Statusdata,0,STATUS_SIZE);
	Status = (struct Status_s *)Statusdata;
	Status_m = Status;
	memset(Adjdata,0,AD_SIZE);
	p_Adj = (struct Adjustments *)Adjdata;
	p_Adj_m = p_Adj;
}

//###########################################################
volatile unsigned int ADCMeasure(unsigned char Pin)
//###########################################################
{
	unsigned int result;
	ADMUX |= Pin;
	//Hngt sich an dieser Stelle immer auf, daher ausgeklammert.
	//while ((ADCSRA& (1<<ADSC))!=0){asm("nop");}; //Wartet auf Beeindigung des Messvorgangs
	result = ADCL;
	result |= (ADCH<<8);//Mit dem Auslesen von ADCH, wird der nchste Messvorgang initiiert. ADCL muss daher als erstes gelesen werden
	return result;
}

//###########################################################
void wait_on_ee(void)
//###########################################################
{
	while(eeprom_is_ready()==0){asm("nop");};
}

//###########################################################
void read_ee_values(void)
//###########################################################
{
	wait_on_ee();
	eeprom_read_block(Adjdata, AD_ADRESS, AD_SIZE);
}

//###########################################################
void write_ee_values(void)
//###########################################################
{
	wait_on_ee();
	eeprom_write_block(Adjdata, AD_ADRESS, AD_SIZE);
}

/*unsigned char LineSize(*string)
{
	unsigned char z=3;//Drei, da die Statuswerte nicht gelesen werden sollen.
	
	while((string[z]!=0x0A)&&(string[z]!=0)){z++;};
	
	return z-3;

}*/

void StepperPower(unsigned char value)
{
	if (value==ON){
		Engine_PORT |= (1<<EN_0)|(1<<EN_1);
	}
	else{
		Engine_PORT &= ~((1<<EN_0)|(1<<EN_1));
	}

}


//###########################################################
void Control_Dremel()
//###########################################################
{
	if (Status->EngineDirection[3]==ON){
		CONTROL_PORT &= ~(1<<DREMEL);
	}
	else{
		CONTROL_PORT |=  1<<DREMEL;
	}
}

//##########################################################
void SetEngineSpeed(unsigned char Speed, unsigned char Device)
//###########################################################
{
	switch (Device){
		case 0:
		case 1:{
			OCR2 = Speed;//Schwellwert des Timers wird beschrieben
		}break;
		case 2:{
			p_Adj->High_Speed = Speed;
			Status->Servospeed = p_Adj->Low_Speed;
			write_ee_values();
		}break;
		case 3:{
			p_Adj->Low_Speed = Speed;
			Status->Servospeed = p_Adj->Low_Speed;
			write_ee_values();
		}break;
	}
}

//###########################################################
void Bohrmanager(void)
//###########################################################
{
	switch (Auftragsstatus.Fortschritt){
		case 0:{//Servo: nach oben, Motor an
			Status->EngineDirection[3] = ON;
			Control_Dremel();
			Status->Servospeed = p_Adj->High_Speed;
			Status->GPosition[2] = p_Adj->Up_Position;
			Koordinatensteuerung = 1;
			Rueckgabewert_s = 2;
			Auftragsstatus.Fortschritt = 1;
			Auftragsstatus.Prozess = BOHREN;
			ServoLogigk();
		}break;
		case 1:{//Mitte 
			Status->Servospeed = p_Adj->High_Speed;
			Status->GPosition[2] = p_Adj->Middle_Position;
			Auftragsstatus.Fortschritt = 2;
			ServoLogigk();
		}break;
		case 2:{//unten
			Status->Servospeed = p_Adj->Low_Speed;
			Status->GPosition[2] = p_Adj->Down_Position;
			Auftragsstatus.Fortschritt = 3;
			ServoLogigk();
		}break;
		case 3:{//Loch bohren/frsen, danach hochfahren.
			if (Fraese.Lochdurchmesser!=0){
				if (Fraese.Winkel==0){
					Fraese.Motorspeed_tmp = OCR2;
					SetEngineSpeed(p_Adj->Fraes_speed,0); //reduziere Geschwindigkeit zum Frsen					
					Rueckgabewert_s = 0;
					//Mittelpunkt des zu Frsenden Kreises
					Fraese.X_Start = Status->Position[0]; Fraese.Y_Start = Status->Position[1];
					
					
					Lochfraesungsmanager();
					Fraese.Winkel++;
				
					Rueckgabewert = 2;
					Motorlogik();					
				}
				else if (Fraese.Winkel<400){
					Lochfraesungsmanager();
					Fraese.Winkel++;
					Motorlogik();
				}
				else if (Fraese.Winkel==400){ 
					SetEngineSpeed(Fraese.Motorspeed_tmp,0);//erhhe Geschwindigkeit auf den Normalmodus		
					Status->Servospeed = p_Adj->High_Speed; 
					Status->GPosition[2] = p_Adj->Up_Position;
					Auftragsstatus.Fortschritt = 4;
					Rueckgabewert_s = 2;
					Fraese.Winkel = 0;
					ServoLogigk();				
				}
			}
			else{
				Status->Servospeed = p_Adj->High_Speed;
				Status->GPosition[2] = p_Adj->Up_Position;
				Auftragsstatus.Fortschritt = 4;
				ServoLogigk();
			}
			
		}break;
		case 4:{//Dremel: OFF Rckgabewert
			Status->EngineDirection[3] = OFF;
			Control_Dremel();
			Rueckgabewert_s = 0;
			Auftragsstatus.Fortschritt = 0;
			Status->Servospeed = p_Adj->Low_Speed;
			UDR = 'b';
			
		}break;		
	}
}
//###########################################################
void Vorpositionsmanager(void)
//###########################################################
{
	switch (Auftragsstatus.Fortschritt){
		case 0:{
			unsigned char a, Vorpositionierung=0;
			for(a=0;a<2;a++){
				if ((PositionCache[a]<Status->GPosition[a])&&(PositionCache[a]>VORPOSITIONSVER)){
					Status->GPosition[a] = PositionCache[a]-200;
					Vorpositionierung = 1;
				}
				else{
					Status->GPosition[a] = PositionCache[a];
				}
			}
			if (Vorpositionierung){
				Auftragsstatus.Fortschritt = 1;
				Auftragsstatus.Prozess = VORPOSITION;
				Rueckgabewert = 2;
			}
			else{
				Status->GPosition[0] = PositionCache[0];
				Status->GPosition[1] = PositionCache[1];
				Auftragsstatus.Fortschritt = 0;		
				Rueckgabewert = 1;		
				Auftragsstatus.Prozess =  KEIN_AUFTRAG;
			}
			Koordinatensteuerung = 1;
			Motorlogik();
		}break;
		case 1:{
			Status->GPosition[0] = PositionCache[0];
			Status->GPosition[1] = PositionCache[1];
			Koordinatensteuerung = 1;
			Auftragsstatus.Fortschritt = 0;	
			Rueckgabewert = 1;		
			Auftragsstatus.Prozess =  KEIN_AUFTRAG;
			Koordinatensteuerung = 1;
			Motorlogik();		
				
		}break;	
	}
}

//###########################################################
void Lochfraesungsmanager()//Frst Kreis im entsprechenden Winkelbereich
//###########################################################
{
	unsigned int Winkel;
	
	Winkel = Fraese.Winkel;
	if (Fraese.Winkel>360){
		Winkel -= 360;
	}
	
	if (Winkel<=90){
		Status->GPosition[0] = Fraese.X_Start + pgm_read_word(&curve_bla[Winkel])/(10000/(Fraese.Lochdurchmesser/2));
		Status->GPosition[1] = Fraese.Y_Start + pgm_read_word(&curve_bla[90-Winkel])/(10000/(Fraese.Lochdurchmesser/2));
	}
	else if (Winkel<=180){
		Status->GPosition[0] = Fraese.X_Start + pgm_read_word(&curve_bla[90-(Winkel-90)])/(10000/(Fraese.Lochdurchmesser/2));
		Status->GPosition[1] = Fraese.Y_Start - pgm_read_word(&curve_bla[Winkel-90])/(10000/(Fraese.Lochdurchmesser/2));	
	}
	else if (Winkel<=270){
		Status->GPosition[0] = Fraese.X_Start - pgm_read_word(&curve_bla[Winkel-180])/(10000/(Fraese.Lochdurchmesser/2));
		Status->GPosition[1] = Fraese.Y_Start - pgm_read_word(&curve_bla[90-(Winkel-180)])/(10000/(Fraese.Lochdurchmesser/2));	
	}		
	else if (Winkel<=360){
		Status->GPosition[0] = Fraese.X_Start - pgm_read_word(&curve_bla[90-(Winkel-270)])/(10000/(Fraese.Lochdurchmesser/2));
		Status->GPosition[1] = Fraese.Y_Start + pgm_read_word(&curve_bla[Winkel-270])/(10000/(Fraese.Lochdurchmesser/2));	
	}
	
}
//###########################################################
void Linienfraesungsmanager()//Frst Linien im entsprechenden Winkelbereich
//###########################################################
{
	unsigned int Winkel;
	
	Winkel = Fraese.Winkel;
	if (Fraese.Winkel>360){
		Winkel -= 360;
	}
	
	if (Winkel<=90){
		Status->GPosition[0] = Fraese.X_Start + pgm_read_word(&curve_bla[Winkel])/(10000/(Fraese.Lochdurchmesser/2));
		Status->GPosition[1] = Fraese.Y_Start + pgm_read_word(&curve_bla[90-Winkel])/(10000/(Fraese.Lochdurchmesser/2));
	}
	else if (Winkel<=180){
		Status->GPosition[0] = Fraese.X_Start + pgm_read_word(&curve_bla[90-(Winkel-90)])/(10000/(Fraese.Lochdurchmesser/2));
		Status->GPosition[1] = Fraese.Y_Start - pgm_read_word(&curve_bla[Winkel-90])/(10000/(Fraese.Lochdurchmesser/2));	
	}
	else if (Winkel<=270){
		Status->GPosition[0] = Fraese.X_Start - pgm_read_word(&curve_bla[Winkel-180])/(10000/(Fraese.Lochdurchmesser/2));
		Status->GPosition[1] = Fraese.Y_Start - pgm_read_word(&curve_bla[90-(Winkel-180)])/(10000/(Fraese.Lochdurchmesser/2));	
	}		
	else if (Winkel<=360){
		Status->GPosition[0] = Fraese.X_Start - pgm_read_word(&curve_bla[90-(Winkel-270)])/(10000/(Fraese.Lochdurchmesser/2));
		Status->GPosition[1] = Fraese.Y_Start + pgm_read_word(&curve_bla[Winkel-270])/(10000/(Fraese.Lochdurchmesser/2));	
	}
}

//###########################################################
void Motorlogik(void)
//###########################################################
{
	unsigned char a;
	if (Koordinatensteuerung){
	
		/*if (Status->Position[1]!=Status->Position_Cache[1]){//Abfrage, ob sich der Wert gendert hat. 
			Status->Korrigierte_Position[1] = (int)((double)(Status->Position[1])*p_Adj->Korrekturfaktor[1]);
			if ((Status->Korrigierte_Position[1]==0)||(Status->Position[1]==Status->GPosition[1])){
				Status->Korrigierte_Position[1] = Status->Position[1];//Keine Korrektur
			}
			Status->Position_Cache[1] = Status->Position[1];
		}*/
		
		Status->Korrigierte_Position[1] = Status->Position[1];//Keine Korrektur*/
		Status->Korrigierte_Position[0] = Status->Position[0];//Keine Korrektur*/
		
		for (a=0;a<2;a++){
			if (Status->Korrigierte_Position[a] < Status->GPosition[a]){
				Status->EngineDirection[a] = 1;
			}
			else if (Status->Korrigierte_Position[a] > Status->GPosition[a]){
				Status->EngineDirection[a] = 2;
			}
			else{
				Status->EngineDirection[a] = 0;
			}
		}
		
		if ((Status->EngineDirection[0] == 0)&&(Status->EngineDirection[1] == 0)){
			switch (Rueckgabewert){
				case 1:{
					Rueckgabewert = 0;
					UDR = 'm';
				}break;
				case 2:{
					switch (Auftragsstatus.Prozess){
						case VORPOSITION:{
							Vorpositionsmanager();
						}break;
						case LOCHFRAESEN:{
							Lochfraesungsmanager();
						}break;
						case BOHREN:{
							Bohrmanager();
						}break;
				
						
					}
				}break;				
			}
		}
	}
	else{
		Status->GPosition[0] = Status->Position[0];
		Status->GPosition[1] = Status->Position[1];
	}
	
	//Kontakt mit Taster
	for (a=0;a<2;a++){
		if ((a!=2)&&((PINA&(1<<((1-a)*R0+a*R1)))==0)){
			if (Status->EngineDirection[a]==2){
				Engine_Direction_Counter = 0;//Fr die Direktsteuerng im Men
				Status->EngineDirection[a] = 0;
				Status->GPosition[a] = Status->Position[a];
				if (Status->EngineDirection[1-a]==0){//Entgegengetzer Motor
					Koordinatensteuerung = 1;
					Motorlogik();
				}
			}
		}
	}
	
	if ((Status->EngineDirection[0]==0)&&(Status->EngineDirection[1]==0)){
		stop_timer_8_2();
	}
	else if ((Status->EngineDirection[0]!=0)||(Status->EngineDirection[1]!=0)){
		Engine_PORT |= (1<<EN_0)|(1<<EN_1);//Falls noch nicht erfolgt: Schritmotoren an.
		init_timer_8_2();
	}
}

//###########################################################
void SetFraeseDurchmesser(unsigned int durchmesser)
//###########################################################
{
	if (durchmesser>p_Adj->Fraeser_Size){
		//Fehlerkorrektur, da kein perfekter Kreis gefrst werden kann.
		if (durchmesser<100){
			durchmesser += 10;
		}
		else if (durchmesser<120){
			durchmesser += 10;
		}
		else{
			durchmesser += 10;
		}
		
		Fraese.Lochdurchmesser = durchmesser-p_Adj->Fraeser_Size;
		
	}
	else{
		Fraese.Lochdurchmesser = 0;
	}
}

//###########################################################
ISR (USART_RXC_vect)// Interrupts, welches auf eingehende Signale des UART reagiert.
//###########################################################
{
	unsigned char Value;
	Value = UDR;
		
	printf("b");
	if ((Value!=0)&&(Transference==0)){ //Diese Abfrage ist notwendig, um in den Programmiermodus zu gelangen
		CommandData[0] = Value>>4;
		DataAmount = Value & 15;
		Transference++;
	}
	else if (Transference<DataAmount){
		CommandData[Transference] = Value;
		Transference++;
	}
	else if (Transference>=DataAmount){
		CommandData[Transference] = Value;
		Transference = 0;
		switch(CommandData[0]){
			case 1:{ //Direktsteuerung der Geschwindigkeit. Value = 18 
				SetEngineSpeed(CommandData[2],CommandData[1]);
			}break;
			case 2:{ //GewnschtePositionsbestimmung der X- und Y-Achse. Value = 37
				if (CommandData[1]){
					PositionCache[0] = (CommandData[3]<<8)|CommandData[2];
					PositionCache[1] = (CommandData[5]<<8)|CommandData[4];
					Auftragsstatus.Fortschritt = 0;
					Vorpositionsmanager();				
				}
				else{
					Status->GPosition[0] = (CommandData[3]<<8)|CommandData[2];
					Status->GPosition[1] = (CommandData[5]<<8)|CommandData[4];
					Koordinatensteuerung = 1;
					Rueckgabewert = 1;
					Motorlogik();
				}
			}break;
			case 3:{ //Positionsbestimmung der X- und Y-Achse. Value = 52
				Status->Position[0] = (CommandData[2]<<8)|CommandData[1];
				Status->Position[1] = (CommandData[4]<<8)|CommandData[3];
				Status->GPosition[0] = (CommandData[2]<<8)|CommandData[1];
				Status->GPosition[1] = (CommandData[4]<<8)|CommandData[3];
				Koordinatensteuerung = 1;
			}break;			
			case 5:{ //Direktsteueurng der Motoren. Value = 82
				Koordinatensteuerung = 0;
				Rueckgabewert = 0;	
				Status->EngineDirection[CommandData[1]] = CommandData[2];
				if (CommandData[1]<2){
					Motorlogik();
				}
				else{
					ServoLogigk();
				}
			}break;
			case 6:{ //Steuerung des Dremels. Value = 97
				Status->EngineDirection[3] = CommandData[1];
				Control_Dremel();
			}break;
			case 7:{ //GewnschtePositionsbestimmung der Z-Achse. Value = 114
				Status->GPosition[2] = (CommandData[2]<<8)|CommandData[1];
				Koordinatensteuerung = 1;
				Rueckgabewert = 1;
				ServoLogigk();
			}break;
			case 8:{ //Positiosabfrage. Value = 129
				if (CommandData[1] < 3){
					UDRValue = Status->Position[CommandData[1]];
					UDR = (unsigned char)UDRValue;
				}
				else{
					UDR = (unsigned char)(UDRValue>>8);
				}			
			}break;
			case 9:{ //Abfrage von Bohrzeitzaehler. Value = 145
				if (CommandData[1]==1){
					Bohrzeitzaehler = 13;
				}
				else{
					UDR = (unsigned char)Bohrzeitzaehler; //Zeitbergabe mit 50 ticks pro Sekunde
				}
			}break;
			case 10:{ //Auftrag zum Bohren. Value = 161
				Auftragsstatus.Fortschritt = 0;
				SetFraeseDurchmesser(CommandData[1]*10);
				Bohrmanager();
			}break;	
			case 11:{ //Bestimmung und Befehl zum Anfahren der drei Positionen: Top, Startdle und Down. Value = 178
				switch (CommandData[1]){
					case 0:{
						if (CommandData[2]){
							p_Adj->Up_Position = Status->Position[2];
							write_ee_values();
						}
						else{
							Status->GPosition[2] = p_Adj->Up_Position ;
							Koordinatensteuerung = 1;
							Status->Servospeed = p_Adj->Low_Speed;
							Rueckgabewert_s = 1;
							ServoLogigk();
						}
					}break;
					case 1:{
						if (CommandData[2]){
							p_Adj->Middle_Position = Status->Position[2];
							write_ee_values();
						}
						else{
							Status->GPosition[2] = p_Adj->Middle_Position ;
							Koordinatensteuerung = 1;
							Status->Servospeed = p_Adj->Low_Speed;
							Rueckgabewert_s = 1;
							ServoLogigk();
						}
					}break;
					case 2:{
						if (CommandData[2]){
							p_Adj->Down_Position = Status->Position[2];
							write_ee_values();
						}
						else{
							Status->GPosition[2] = p_Adj->Down_Position ;
							Koordinatensteuerung = 1;
							Status->Servospeed = p_Adj->Low_Speed;
							Rueckgabewert_s = 1;
							ServoLogigk();
						}
					}break;					
				}
			}break;
			case 12:{ //Enable/Disable Steppers 193
				StepperPower(CommandData[1]);
			}break;
			case 13:{ //209 Potimode ein/aus
				p_Adj->Fraes_speed = CommandData[1];
			}break;
			case 14:{ //225 Potimode ein/aus
				p_Adj->Potimode = CommandData[1];
			}break;
		}
	}
}



//###########################################################
void ServoLogigk(void)//Entsprechend der SERVO_TAKT_FREQUENZ aufzurufen
//###########################################################
{
	if (Koordinatensteuerung){
		if (Status->Position[2]<(Status->GPosition[2]-POTI_TOLLERANZ*p_Adj->Potimode)){
			Status->EngineDirection[2] = 1;
			
			if ((Status->GPosition[2]-Status->Position[2])<Status->Servospeed){ //Damit der gewnschte Wert nicht bersprungen wird
				Servowert += 1;
			}
			else{
				Servowert += Status->Servospeed;
			}
			Sicherheitszaehler = 0;
		}
		else if (Status->Position[2]>(Status->GPosition[2]+POTI_TOLLERANZ*p_Adj->Potimode)){
			Status->EngineDirection[2] = 2;
			
			if ((Status->Position[2]-Status->GPosition[2])<Status->Servospeed){ //Damit der gewnschte Wert nicht bersprungen wird
				Servowert -= 1;
			}
			else{
				Servowert -= Status->Servospeed;
			}
			Sicherheitszaehler = 0;
		}
		else{
			Status->EngineDirection[2] = 0;
			Sicherheitszaehler++;
			if (Sicherheitszaehler>(SICHERHEITS_COUNT*p_Adj->Potimode)){
				switch (Rueckgabewert_s){
					case 1:{
						UDR = 'p';
						Rueckgabewert_s = 0;
					}break;
					case 2:{
						switch (Auftragsstatus.Prozess){
							case BOHREN:{
								Bohrmanager();
							}break;
				
						}
					}break;	
				}
			}
		}
	}
	
	//Dieser Komplex ist dazu gedacht, das Servosignal whrend der Ruhephase zum erliegen zu bringen, 
	//damit es keine Komplikationen bei gleichzeitiger Motorsteuerung gibt.
	if ((Status->EngineDirection[2]==0)&&(Sicherheitszaehler>SICHERHEITS_COUNT*p_Adj->Potimode)){
		stop_timer_16();
	}
	else if ((Status->EngineDirection[2]!=0)&&(TCCR1B==0)){//TCCR1B=0 -> Timer inaktiv
		init_timer_16(8,Servowert);
		CONTROL_PORT |= 1<<SERVO; //Motorpin an
	}
	else{
		init_timer_16(8,Servowert);
		CONTROL_PORT |= 1<<SERVO; //Motorpin an
	}

	if (Koordinatensteuerung==0){
		if (Status->EngineDirection[2]==1){
			Servowert += Status->Servospeed;
			
			if (Servowert>SERVO_MAX){
				Servowert = SERVO_MAX;
				Status->EngineDirection[2] = 0;
			}	
		}	
		else if (Status->EngineDirection[2]==2){
			Servowert -= Status->Servospeed;

			if (Servowert<SERVO_MIN){
				Servowert = SERVO_MIN;
				Status->EngineDirection[2] = 0;
			}
		}
	}
}

//###########################################################
void init_Bohreinheit(void)
//###########################################################
{
	Engine_PORT_INI = Enginge_PORT_INI_VALUE;
	Engine_PORT &= ~Enginge_PORT_INI_VALUE;
	Engine_PORT |= (1<<CLK_0)|(1<<CLK_1);//Schrittmotortreiberchips bleiben zunchst deaktivieren, CLK muss High sein.
	CONTROL_PORT_INI = (1<<SERVO)|(1<<DREMEL);
	CONTROL_PORT = (1<<R0)|(1<<R1);//Pullup fr int0 und int1
	
	
	init_timer_16(1024,SERVO_TAKT_FREQUENZ);
	init_timer_8_2();
	
	read_ee_values();
	if (p_Adj->Low_Speed==255){
		p_Adj->Low_Speed = 3;
		p_Adj->High_Speed = 30;
		p_Adj->Fraes_speed = 100;
		p_Adj->Fraeser_Mode_On = ON;
		p_Adj->Fraeser_Size = 80;
		p_Adj->Stepper_Speed = 10;
		p_Adj->Zero_Pos[0] = 124;
		p_Adj->Zero_Pos[1] = 211;
		p_Adj->Up_Position = 2968;
		p_Adj->Middle_Position = 2550;
		p_Adj->Down_Position = 2146;
		p_Adj->Korrekturfaktor[1] = 0;//0.9963//0.9913/0.9950
	}
	SetEngineSpeed(p_Adj->Stepper_Speed,0);
	
	Status->Servospeed = p_Adj->Low_Speed;
	
	Status->EngineDirection[0] = 0;
	Status->EngineDirection[1] = 0;
	Status->EngineDirection[2] = 1;	//Servo hochfahren
	Status->EngineDirection[3] = OFF;
	Koordinatensteuerung = 0;
	Control_Dremel();
	ServoLogigk();
	
	Clock_Syckle = 0;
	
	EngineStepStatus[0] = 0;
	EngineStepStatus[1] = 0;
	Status->Position[0] = 0;
	Status->Position[1] = 0;
	Status->GPosition[0] = 0;
	Status->GPosition[1] = 0;	
	Status->GPosition[2] = SERVO_MAX;
	Status->Position_Cache[1] = 0;
	Rueckgabewert = 0;
	
	Servowert = SERVO_MAX;
	p_Adj->Potimode = 0;
	Fraese.Winkel = 0;
	
	Engine_Direction_Counter = 0; //Wird fr die Direktsteuerung benutzt
	


	
	// ADC Aktivieren, Free running, Teilungsfaktor auf 64, Starten.
	ADCSRA = (1<<ADEN)|(1<<ADATE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADSC);
	
	/*Interupts, welche bei einem bestimmten Schwellwert des Timer1 und Timer2 aktiviert werden.
	Auerdem ist das Overflow-Interrupt des Timer0 aktiviert*/
	TIMSK |= (1<<OCIE1A)|(1<<OCIE2);
	    
	
}

#endif


