#ifndef _bohrer_h_
	#define _bohrer_h_

extern void wait_on_ee(void);
extern void read_ee_values(void);
extern void write_ee_values(void);
extern void Control_Dremel(void);
extern void Bohrmanager(void);
extern void Vorpositionsmanager(void);
extern void SetEngineSpeed(unsigned char Speed, unsigned char Device);
extern void ServoLogigk(void);
extern void Motorlogik(void);
extern void init_Bohreinheit(void);
extern volatile unsigned int ADCMeasure(unsigned char Pin);
extern void Lochfraesungsmanager(void);
extern void Linienfraesungsmanager(void);


#define SERVO_MAX 4200 // oben 
#define SERVO_MIN 2000 //unten
#define SERVO_TAKT_FREQUENZ 316 //20ms
#define STEPPER_SPEED_MIN 10
#define STEPPER_SPEED_MAX 255
#define POTI_TOLLERANZ 10
#define SICHERHEITS_COUNT 15
#define RANDABSTAND 30


/*#define DATEIENDE 5
#define NEXT 1
#define LAST 0*/

#define CONTROL_PORT PORTA
#define CONTROL_PORT_INI DDRA

#define Engine_PORT PORTB
#define Engine_PORT_INI DDRB
#define Enginge_PORT_INI_VALUE 252

//Pins am 297-Chip

#define CLK_0 3
#define CLK_1 6
#define DIR_0 2
#define DIR_1 5
#define EN_0 7
#define EN_1 4


#define SERVO 5
#define DREMEL 4 
#define R0 3
#define R1 2
#define POTI 7

#define ON 1
#define OFF 0

//Manager
/*#define NOTHING 0
#define GET_ZERO_POS 1
#define MAKEHOLES 2
#define SERIE_COMPLETE 3
#define STOP 4*/


#define VORPOSITIONSVER 50


struct Loch_s//Size 4
{
	unsigned char Size; //0
	unsigned int Count; //1
	unsigned char Zuordnung; //3
};



#define STATUS_SIZE 60
struct Status_s
{
	unsigned char EngineDirection[4];//0
	signed int Position[3];//4
	signed int GPosition[3];//10
	unsigned char Servospeed;//16
	unsigned char aktuelleLochgroesse;//17
	unsigned int LochPos;//18
	unsigned char GebohrteLoecher;//20
	unsigned char ZugerodneteLochgroessen[21];//21 (LOCHGROESSENANZAHL)
	unsigned char Bohrprozess;//41
	unsigned char Fortschritt;//42
	unsigned char Progress;//43
	unsigned int Randabstand[2];//44 (4)
	signed int Position_Cache[2];//48 (4)
	signed int Korrigierte_Position[2];//52 (4)
	unsigned char Excellon;//56	
};


extern unsigned char Koordinatensteuerung;
extern unsigned char EngineStepStatus[2];
extern unsigned char Transference;
extern unsigned char CommandData[16];
extern unsigned char DataAmount;
extern signed int PositionCache[3];
extern unsigned int UDRValue;
extern unsigned char Rueckgabewert;
extern unsigned char Rueckgabewert_s;
extern unsigned int Bohrzeitzaehler;
extern unsigned char Servostatus;
extern unsigned char Interupt_running;
extern unsigned char Clock_Syckle;
extern unsigned int Servowert;
extern unsigned char Sicherheitszaehler;
extern signed char Engine_Direction_Counter;
extern unsigned char EngineSpeed_Cache;
extern unsigned char GetLochData_Pos( unsigned int *x, unsigned int *y, signed int pos);


extern void MotorLogik(void);
extern void SetFraeseDurchmesser(unsigned int durchmesser);
extern unsigned char Manager(void);
extern unsigned char getHoleSize(unsigned char direction);
extern void StepperPower(unsigned char value);
extern void initStructs(void);



#define AD_ADRESS 0
#define AD_SIZE 40

struct Adjustments 
{	
	unsigned char Low_Speed;		//0
	unsigned char High_Speed; 		//1
	unsigned int Up_Position;		//2
	unsigned int Middle_Position;	//4
	unsigned int Down_Position;	//6
    unsigned char Fraes_speed;		//8
	unsigned char Stepper_Speed;	//9
	unsigned char Potimode;		//10
	unsigned char Fraeser_Mode_On;	//11
	unsigned int Fraeser_Size;		//12
	unsigned int Zero_Pos[2];		//14 (4)
	double Korrekturfaktor[2];//18 (8)
};

//Auftragsstatus Prozess
#define KEIN_AUFTRAG 0
#define BOHREN 1
#define VORPOSITION 2
#define LOCHFRAESEN 3
#define GETPOSITION 4

struct
{
	volatile unsigned char Prozess;
	volatile unsigned int Fortschritt;
} Auftragsstatus;

struct
{
	unsigned int Winkel;//1-360
    unsigned int Lochdurchmesser;
    unsigned int X_Start;
    unsigned int Y_Start;
    unsigned int X_Stop;
    unsigned int Y_Stop;	
    unsigned char Motorspeed_tmp;
} Fraese;

unsigned char Adjdata[AD_SIZE];
struct Adjustments *p_Adj, *p_Adj_m;

unsigned char Statusdata[STATUS_SIZE];
struct Status_s *Status,*Status_m;





#endif//_main_h_
