#ifndef _main_c
#define _main_c

#include "main.h"



//Installation der Seriellen Schnittstelle
void IOInit (void)
{
	/* Der Empfangs (RXEN) und Sendemodus (TXEN) wird aktiviert. Auerdem erfolgt die Aktivierung 
	des Interrupts, welches auf eingehende Signale des UART reagiert (RXCIE) und zu guter 
	letzt wird das UART Datenregister Leer Interrupt (UDRIE) aktiviert*/
    UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);
	
	//Teiler wird gesetzt 
	UBRR = sysclk / (baud_rate * 16L) - 1;
}


//Routine fr printf
int uart_putchar (char c,FILE *file)
{
	if (c == '\n')
		uart_putchar('\r',file);
	//Warten solange bis Zeichen gesendet wurde
	loop_until_bit_is_set(USR, UDRE);
	//Delay1ms(50);
	//UDR = c;
	D_Add_Char(c);
	return (0);
}

//Hauptprogramm
int main (void)
{
	//unsigned int i;
	//Delay1ms(500);
	
	//Initzialisierung der seriellen Schnittstelle
	IOInit();
	//ffnet einen kanal fr printf //fdevopen (uart_putchar, NULL, 0);
	fdevopen (uart_putchar, NULL);	
	
	initStructs();
	init_display();
	init_Bohreinheit();
	sei();
	
	printf("System OK");
	//Backlight_On(ON);	
	
	//Initialisiere MMC Karte und Dos
	//I2cSendData[0] = 'i';
	//i2cMasterSendNI(TARGET_ADDR,1,I2cSendData);	
	//i2cMasterReceiveNI(TARGET_ADDR,1,I2cReceiveData);
	
	/*unsigned char cache[10] = "t Hello";
	Delay1ms(200);
	i2cMasterSendNI(TARGET_ADDR,7,cache);
	cache[3] = 0;
	i2cMasterReceiveNI(TARGET_ADDR,7,cache);		
	printf(cache+1);*/	
	
	/*
	I2cSendData[0] = 'e';
	memcpy(I2cSendData+1,"File2.txt",10);			
	i2cMasterSendNI(TARGET_ADDR,11,I2cSendData);
	i2cMasterReceiveNI(TARGET_ADDR,2,I2cReceiveData);
	printf("Rueckgabe: %d",I2cReceiveData[1]);
	*/
	
	//Hauptprogramm luft stndig in einer schleife und macht nichts
	while (1){
		asm("nop");
	}
	
	return (1);
}
#endif

